unit magischeQuadrat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, About, Menus, EingabeSL;

type
  T2DArray=Array of Array of Integer;  // 2-dimensionales Array
  TMagie = class(TForm)
    Matrix: TStringGrid;
    MainMenu: TMainMenu;
    Option: TMenuItem;
    Fuellen: TMenuItem;
    Info: TMenuItem;
    Procedure FuellenClick(Sender: TObject);
    Procedure Init(Var KL,MagischeZahl:Integer;Var M:T2DArray);
    Procedure UngeradeFuellen(KL:Integer;Var M:T2DArray);
    Procedure Ausgabe(KL,MagischeZahl:Integer;M:T2DArray);
    Procedure Spiegele(KL,XVon,XBis,YVon,YBis:Integer;Var Quadrat:T2DArray);
    Procedure DurchVierFuellen(KL:Integer;Var Quadrat:T2DArray);
    Procedure DurchSonst(KL:Integer;Var Quadrat:T2DArray);
    procedure InfoClick(Sender: TObject);
    procedure OptionClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  End;

Var
  Magie: TMagie;

implementation

{$R *.DFM}
{$R+,Q+}

 Procedure TMagie.Init(Var KL,MagischeZahl:Integer;Var M:T2DArray);
  Var X,Y:Integer;
  Begin
   KL:=StrToInt(Options.Ordnung.Text);
   with Matrix do
    begin
     RowCount:=KL+1;
     ColCount:=KL+1;
     Width:=ColCount*(DefaultColWidth+GridLineWidth)+4;
     Height:=RowCount*(DefaultRowHeight+GridLineWidth)+4;
     Magie.Width:=Width+20;
     Magie.Height:=Height+60;
     Magie.Position:=poScreenCenter;
    end;
   For Y:=0 To Matrix.RowCount-1 Do
    For X:=0 To Matrix.ColCount-1 Do Matrix.Cells[X,Y]:='';
   MagischeZahl:=(KL*KL*KL+KL) Div 2;
   SetLength(M,KL+1,KL+1); // Seitenlnge: 0 bis KL, wegen des Rahmen
   For Y:=1 To KL Do
    For X:=1 To KL Do M[X,Y]:=0;
  End;

 Procedure TMagie.UngeradeFuellen(KL:Integer;Var M:T2DArray);
  Var X,Y,AN,Wert:Integer;
  Begin
   Y:=1;X:=KL Div 2+1;AN:=KL*KL;
   For Wert:=1 To AN Do
    Begin
     M[X,Y]:=Wert;Dec(Y);Inc(X);
     If Y=0 Then Y:=KL;
     If X>KL Then X:=1;
     If M[X,Y]>0 Then
      Begin
       Dec(X);Inc(Y,2);                  // unter die aktuelle Zahl
       if X=0 then Begin X:=KL;Y:=2 end; // Hauptdiagonale oben rechts
      End
    End;
  End;

 Procedure TMagie.Spiegele(KL,XVon,XBis,YVon,YBis:Integer;Var Quadrat:T2DArray);
  Var Tausch,X,Y:Integer;
  Begin
   For X:=XVon To XBis Do
    For Y:=YVon To YBis Do
     Begin
      Tausch:=Quadrat[X,Y];
      Quadrat[X,Y]:=Quadrat[KL+1-X,KL+1-Y];
      Quadrat[KL+1-X,KL+1-Y]:=Tausch
     End
  End;

 Procedure TMagie.DurchVierFuellen(KL:Integer;Var Quadrat:T2DArray);
  Var X,Y:Integer;
  Begin
   // Feld wird mit 1..N^2 besetzt
   For Y:=1 To KL Do
    For X:=1 To KL Do Quadrat[X,Y]:=(Y-1)*KL+X;
   // Quadrat oben links mit unten rechts punktspiegeln
   Spiegele(KL,1,KL Div 4,1,KL Div 4,Quadrat);
   // Quadrat unten links mit oben rechts punktspiegeln
   Spiegele(KL,1,KL Div 4,1+3*(KL Div 4),KL,Quadrat);
   // mittlere Quadrat punktspiegeln
   Spiegele(KL,1+KL Div 4,KL Div 2,1+KL Div 4,3*(KL Div 4),Quadrat)
  End;

 Procedure TMagie.DurchSonst(KL:Integer;Var Quadrat:T2DArray);
  Var M:T2DArray;
      K,KorrekturZahl,N,X,Y,I:Integer;
      Zeile:String;
  Begin
   N:=KL-2;KorrekturZahl:=KL*KL+1;K:=N Div 4;
   SetLength(M,N+1,N+1);
   DurchVierFuellen(N,M);
   For Y:=1 To N Do
    For X:=1 To N Do Quadrat[X+1,Y+1]:=M[X,Y]+2*KL-2;
   Quadrat[1,1]:=1;Quadrat[KL,1]:=2;
   Quadrat[1,KL]:=KorrekturZahl-2;Quadrat[KL,KL]:=KorrekturZahl-1;
   Zeile:='OOU';
   For I:=1 To K-1 do Zeile:=Zeile+'O';
   For I:=1 To 2*K-1 do Zeile:=Zeile+'U';
   For I:=1 To K-1 do Zeile:=Zeile+'O';
   Zeile:=Zeile+'U';
   For I:=1 To K do Zeile:=Zeile+'L';
   For I:=1 To K+1 do Zeile:=Zeile+'R';
   Zeile:=Zeile+'O';
   For I:=1 To K-1 do Zeile:=Zeile+'R';
   For I:=1 To K do Zeile:=Zeile+'L';
   For I:=3 To 2*KL-2 do
    Case Zeile[I] of
      'O': Begin
            X:=1;
            While Quadrat[X,1]>0 do Inc(X);
            Quadrat[X,1]:=I;Quadrat[X,KL]:=KorrekturZahl-I;
           End;
      'U': Begin
            X:=1;
            While Quadrat[X,KL]>0 do Inc(X);
            Quadrat[X,KL]:=I;Quadrat[X,1]:=KorrekturZahl-I;
           End;
      'L': Begin
            Y:=1;
            While Quadrat[1,Y]>0 do Inc(Y);
            Quadrat[1,Y]:=I;Quadrat[KL,Y]:=KorrekturZahl-I;
           End;
      'R': Begin
            Y:=1;
            While Quadrat[KL,Y]>0 do Inc(Y);
            Quadrat[KL,Y]:=I;Quadrat[1,Y]:=KorrekturZahl-I;
           End;
    End
  End;

 Procedure TMagie.Ausgabe(KL,MagischeZahl:Integer;M:T2DArray);
  Var X,Y,Breite:Byte;
  Begin
   For Y:=0 To KL Do
    Matrix.Cells[0,Y]:=IntToStr(MagischeZahl);
   For X:=1 To KL Do
    Matrix.Cells[X,0]:=IntToStr(MagischeZahl);
   Breite:=Length(Matrix.Cells[1,0]);
   For Y:=1 To KL Do
    For X:=1 To KL Do Matrix.Cells[X,Y]:=Format('%'+IntToStr(Breite)+'d',[M[X,Y]]);
  End;

 procedure TMagie.FuellenClick(Sender: TObject);
  Var M:T2DArray;
     KL,MagischeZahl:Integer;
  Begin
   Init(KL,MagischeZahl,M);
   If Odd(KL) Then UngeradeFuellen(KL,M)
   Else If KL mod 4=0 Then DurchVierFuellen(KL,M)
   Else DurchSonst(KL,M);
   Ausgabe(KL,MagischeZahl,M);
 End;

 procedure TMagie.InfoClick(Sender: TObject);
  begin AboutBox.ShowModal end;

 procedure TMagie.OptionClick(Sender: TObject);
  begin Options.Show end;

 End.

